# -*- coding: utf-8 -*-
import sys
from qt import *
from form1 import Form1
import bz2
import random
import os
import cPickle
import codecs
from xml.dom.minidom import parseString

import sre

class Form(Form1):

    def __init__(self,parent = None,name = None,modal = 0,fl = 0):
        Form1.__init__(self,parent,name,modal,fl)
	self.connect(self.textEdit1, SIGNAL("linkClicked(const QString &)"), self.linkClicked)
	self.cachedArticles = {}
	
	self.setCurrentArticle(u"Wikipédia")
	
	
    def launchSearch(self):
	t = unicode(self.lineEdit1.text())
	t = "[%s%s]%s" % (t[0].upper() , t[0].lower() , t[1:])
	latin1 = codecs.utf_8_encode(t)[0]
	p = os.popen('zgrep "' + latin1 + '" fullidx2.txt.gz', 'r')
	matchlist = [codecs.utf_8_decode(x)[0][:-1] for x in p]
	print matchlist
	self.listBox1.clear()
	for w in matchlist:
		self.listBox1.insertItem(w)
	
	
    def loadArticle(self, block, start,length):
	f = bz2.BZ2File( 'frwiki-latest-pages-articles.xml.bz2' )

	L = f.loadBlock(blocksaddr[block],bitaddr[block], start, length)
	
	D = parseString(L)
	
	n = D.getElementsByTagName('title')
	title = n[0].firstChild.nodeValue
	
	n = D.getElementsByTagName('text')
	t = n[0].firstChild.nodeValue
	
	self.text = t
	self.textEdit2.setText(t)
	
		
	#t = t.replace('===\n', '</h3> ').replace('===', '<h3>')
	#t = t.replace('==\n', '</h2> ').replace('==', '<h2>')
	# NOTE : ca plante sur
	#  échelle des temps géologiques, <- non, c'est car on est a la frontiere du bloc 104
	t = sre.sub("=== *(.*)=== *\n", '<h3>\\1</h3>\n', t) 
	t = sre.sub("== *(.*)== *\n", '<h2>\\1</h2>\n', t) 
	t = sre.sub("^ \t]*==[ \t]*(\w)[ \t]*==[ \t]*\n", '<h2>(Image: \\1)</h2>', t) 
	t = sre.sub("{{([^}|]*)([^}]*?)}}", '<i><font color="#FF4400">(Macro:<b> \\1</b>\\2)</font></i>', t)
	t = sre.sub("\[\[[Ii]mage:([^.]*).*\n", '<font color="#FF00CC"><i>(Image: \\1)</i></font><br/>', t) # todo: parser l'interieur
	t = sre.sub("''''(.*?)''''", "<i>\\1</i>", t)
	t = sre.sub("'''(.*?)'''", "<b>\\1</b>", t)
	t = sre.sub("\[\[([^]|]*|)\]\]", '<a href="\\1">\\1</a>', t)
	t = sre.sub("\[\[([^]|]*|)\|([^]]*)\]\]", '<a href="\\1">\\2</a>', t)
	#t = t.replace(']]', '</font>').replace('[[', '<font color="#0000CC">')
	t = t.replace('\n\n', '\n<br/>\n')
	t = t.replace('\n*', '\n<br/>*\t')
	t = t.replace('\n#', '\n<br/>')
	return t, title

    def showArticle(self, titleEntry = None, display=True):
	if titleEntry == None:
		# "Go" button was clicked, readfrom the textbox
		titleEntry = unicode(self.lineEdit1.text())
	else:
		# otherwise, it must have been passed from a link. Check for url.
		url = titleEntry.split('#')
		titleEntry = url[0] # todo : to do
	
	# special feature: load a random article
	if titleEntry == "":
		print "Choosing at random"
		# avoid choosing something containing":", avoir REDIRECT
		t, candidate = "", ":"
		while t[0:9].upper() == "#REDIRECT" or candidate.find(':') > -1:
			i = random.randint(0, len(fulladdr))
			t, candidate = self.loadArticle(*fulladdr[i])
			print "candidate", candidate
		titleEntry = candidate
		self.cachedArticles[titleEntry] = t
		self.listBox3.insertItem(titleEntry, self.listBox3.currentItem() + 1)

	# when loading an article, title have uppercased first word
	elif not titleEntry[0].isupper():
		titleEntry = titleEntry[0].upper() + titleEntry[1:]
	
	if not self.cachedArticles.has_key(titleEntry):
		latin1 = codecs.utf_8_encode(titleEntry)[0]
		p = os.popen('zgrep "^' + latin1 + '\t" output.idx.gz', 'r')
		print p
		# je utf_8_decode pas car je ne m'interesse qu'aux chiffres
		try:
			l = p.readline()
			print l
			block, offset, leng = [int(x) for x in l.split()[-3:]]
		except ValueError:
			self.textLabel1.setText(u"Article Not found : " + titleEntry)
			return
		t, parsedtitle = self.loadArticle(block, offset, leng)
		
		if t[0:9].upper() == "#REDIRECT":
			print t
			destArticle = t[t.index('>')+1:t.rindex('<')]
			if destArticle != titleEntry:
				print '"%s" redirect to "%s"' % (titleEntry, destArticle)
				self.showArticle(destArticle, display = display)
				return
			else:
				print "WARNING: Recursive redirection. Ignored"

		self.cachedArticles[titleEntry] = t
		self.listBox3.insertItem(titleEntry, self.listBox3.currentItem() + 1)
		#self.showArticle(self.currentlyDisplayedArticle)
		
	if display:
		self.textEdit1.setText(self.cachedArticles[titleEntry])			
		self.textLabel1.setText(titleEntry)
		self.currentlyDisplayedArticle = titleEntry
	
		i = self.listBox3.index(self.listBox3.findItem(titleEntry))
		self.listBox3.setCurrentItem(i)

			
		
    def closeCurrentPage(self):
	# todo: ce n'est pas la bonne condition. Il faut verifier len(box) > 1
	c = self.listBox3.currentItem()
	if c > 0:
		del self.cachedArticles[self.currentlyDisplayedArticle]
		self.listBox3.removeItem(c)
	
    def setCurrentArticle(self, articleName):
	self.showArticle(unicode(articleName))
	
		
    def execCode(self):
	code = unicode(self.textEdit3.text())
	t = self.text
	print "Avant", t
	print "Eval, ", code
	exec(code)
	print "Apres", t
	self.textEdit1.setText(t)
	
    def linkClicked(self, a0):
	print "LinkClicked"
	self.showArticle(unicode(a0), display = False)
	# force redisplay the (cached) text since Qt wrongly try to follow url
	self.textEdit1.setText(self.cachedArticles[self.currentlyDisplayedArticle])	

print "Loading block addr..."
#fullnames, fulladdr = cPickle.load(open('fullidx.pickle'))
#fulladdr = cPickle.load(open('fulladdr.pickle'))
blocksaddr = []
bitaddr = []
for k in open('blocksaddr.idx'):
	a, b, c = k.split()
	blocksaddr.append(int(b))
	bitaddr.append(int(c))


if __name__ == "__main__":
    a = QApplication(sys.argv)
    QObject.connect(a,SIGNAL("lastWindowClosed()"),a,SLOT("quit()"))
    w = Form()
    a.setMainWidget(w)
    w.show()
    a.exec_loop()
