import bz2
import gzip
import sys
import codecs
from xml.dom.minidom import parseString
# TODO : write output.idx via a gzip stream
def buildIndex(inputbz2Archive, outidxname, outblockname, callback = None):
 zindexfile = gzip.open(outidxname, 'w') # open in ascii, dunno how to fix :(
 blocksfile = open(outblockname, 'w')
 f = bz2.BZ2File(inputbz2Archive)
 if f.readline()[0:10] != "<mediawiki":
	 print "Maybe not a correct mediawiki bz2 dump"
 blocknum = -1
 numarticles = 0
 try:
  while 1:
   while 1:
	start = f.tell()
	bzblocks = f.tellbzblock()
	if bzblocks[0] != blocknum:
		print "Processing block ", bzblocks[0]
		print numarticles, " articles found"
		if callback:
			callback(bzblocks[2] / 1024)
		blocknum = bzblocks[0]
		blocksfile.write("%d\t%d %d\n" % (blocknum, bzblocks[2], bzblocks[3]))
		##print "Blocknum", blocknum, " byte,bit : ", bzblocks[2:4]
		
        l = f.readline()
        if l == "  <page>\n":
                break
	if l == "":
		raise StopIteration

   #print "article found at (unziped) offset : ", start

   while 1:
        l = f.readline()
	if l[0:11] == '    <title>':
		titleline = l
        if l == "  </page>\n":
                break
	if l == "":
		raise StopIteration

   ending = f.tell()
   D = parseString(titleline)
   n = D.getElementsByTagName('title')
   title = n[0].firstChild.nodeValue
   numarticles += 1

   zindexfile.write( codecs.utf_8_encode("%s\t%s\t%d\t%d\n" % (title, bzblocks[0], start - bzblocks[1], ending - start) )[0] )
 except StopIteration:
   print "End of that block : ", f.name

if __name__ == '__main__':
	filename = sys.argv[1]
	if filename.endswith('.xml.bz2'):
		outidxname = filename[:-8] + 'idx.gz'
		outblockname = filename[:-8] + 'blocks.idx'
		buildIndex(sys.argv[1], outidxname, outblockname)
	else:
		print "first argument should be a wikipedia .xml.bz2 file"